package de.twenty11.skysail.common.ext.dbviewer;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonProperty;

public class ConstraintDetails implements Serializable {

    private static final long serialVersionUID = -1079406626730388016L;

    public static final String ID = "name";

    @NotNull(message = "Id is mandatory")
    @Size(min = 1, message = "Id must not be empty")
    private String id;

    @JsonCreator
    public ConstraintDetails(@JsonProperty("name") String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public Map<String, String> toMap() {
        Map<String, String> result = new HashMap<String, String>();
        result.put(ID, id);
        return result;
    }

    @Override
    public String toString() {
        return id;
    }
}
