package de.twenty11.skysail.common.ext.dbviewer;

import org.restlet.resource.Delete;
import org.restlet.resource.Get;

import de.twenty11.skysail.common.responses.FailureResponse;
import de.twenty11.skysail.common.responses.SkysailResponse;
import de.twenty11.skysail.common.responses.SuccessResponse;

/**
 * Restful Http Service for single Connection.
 * 
 */
public interface RestfulConnection {

    /**
     * @return the associated connection
     */
    @Get
    public SkysailResponse<ConnectionDetails> getConnection();

    /**
     * @param connection connection to update
     * @return a {@link SuccessResponse} or a {@link FailureResponse} with a {@link ConstraintViolations} payload.
     */
    // @Put
    // public SkysailResponse<ConstraintViolations<ConnectionDetails>> updateConnection(ConnectionDetails connection);

    @Delete
    public SkysailResponse<String> deleteConnection();

}
