package de.twenty11.skysail.common.ext.dbviewer;

import java.util.List;

import org.restlet.resource.Get;

import de.twenty11.skysail.common.responses.SkysailResponse;

/**
 * Restful Http Service for Connections.
 * 
 */
public interface RestfulConnections {

    /**
     * Returns a skysail {@link SkysailResponse} containing the list of available connections.
     * 
     * @return a skysail response.
     */
    @Get
    public SkysailResponse<List<ConnectionDetails>> getConnections();

    /**
     * adds a connection to the list of managed connections.
     * 
     * @param entity connection to add
     * @return a {@link SuccessResponse} or a {@link FailureResponse} with a {@link ConstraintViolations} payload.
     */
    // @Post()
    // public ConstraintViolationsResponse<ConnectionDetails>> addConnection(ConnectionDetails entity);

 }
