package de.twenty11.skysail.common.ext.dbviewer;

import java.io.Serializable;
import java.util.Collections;
import java.util.Map;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonIgnore;
import org.codehaus.jackson.annotate.JsonProperty;

import de.twenty11.skysail.common.Presentable;
import de.twenty11.skysail.common.PresentableHeader;

public class SchemaDetails implements Presentable, Serializable {

    private static final long serialVersionUID = -1079406626730388016L;
    public static final String ID = "name";

    @NotNull(message = "Id is mandatory")
    @Size(min = 1, message = "Id must not be empty")
    private String id;
    private Map<String, String> links;

    @JsonCreator
    public SchemaDetails(@JsonProperty("name") String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }
    
    @Override
    public String toString() {
        return id;
    }

    @Override
    @JsonIgnore
    public PresentableHeader getHeader() {
        return new PresentableHeader.Builder(id).setLink("schemas/" + id + "/tables").setImage("icon-folder-close")
                .build();
    }

    @Override
    @JsonIgnore
    public Map<String, Object> getContent() {
        return Collections.emptyMap();
    }

}
